import _classCallCheck from '@babel/runtime/helpers/esm/classCallCheck';
import _createClass from '@babel/runtime/helpers/esm/createClass';
import _inherits from '@babel/runtime/helpers/esm/inherits';
import _createSuper from '@babel/runtime/helpers/esm/createSuper';
import { isEngine, CardType, Card, $, CARD_KEY, Plugin } from '@aomao/engine';
import _get from '@babel/runtime/helpers/esm/get';
import _getPrototypeOf from '@babel/runtime/helpers/esm/getPrototypeOf';

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css_248z = ".am-engine .card-hr,.am-engine-view .card-hr {\r\n    border: 1px solid transparent;\r\n    padding: 18px 0;\r\n    border-radius: 2px 2px;\r\n}\r\n\r\n.am-engine .card-hr hr,.am-engine-view .card-hr hr {\r\n    box-sizing: border-box;\r\n    position: absolute;\r\n    top: 50%;\r\n    left: 0;\r\n    margin-top: -1px;\r\n    width: 100%;\r\n    height: 2px;\r\n    background-color: #e8e8e8;\r\n    padding: 0;\r\n    border: 1px solid transparent;\r\n}\r\n\r\n.am-engine .card-hr:hover , .am-engine .card-hr.hr-activated {\r\n    background-color: #f4f4f4;\r\n}";
styleInject(css_248z);

var Hr = /*#__PURE__*/function (_Card) {
  _inherits(Hr, _Card);

  var _super = _createSuper(Hr);

  function Hr() {
    _classCallCheck(this, Hr);

    return _super.apply(this, arguments);
  }

  _createClass(Hr, [{
    key: "toolbar",
    value: function toolbar() {
      if (!isEngine(this.editor) || this.editor.readonly) return [];
      return [{
        type: 'dnd'
      }, {
        type: 'copy'
      }, {
        type: 'delete'
      }];
    }
  }, {
    key: "onActivate",
    value: function onActivate(activated) {
      _get(_getPrototypeOf(Hr.prototype), "onActivate", this).call(this, activated);

      var activatedClass = 'hr-activated';
      var center = this.getCenter();

      if (activated) {
        center.addClass(activatedClass);
      } else center.removeClass(activatedClass);
    }
  }, {
    key: "onSelectByOther",
    value: function onSelectByOther(selected, value) {
      _get(_getPrototypeOf(Hr.prototype), "onSelectByOther", this).call(this, selected, value);

      this.getCenter().find('hr').css('background-color', selected ? value.rgb : '');
    }
  }, {
    key: "onActivateByOther",
    value: function onActivateByOther(activated, value) {
      this.onSelectByOther(activated, value);
    }
  }, {
    key: "render",
    value: function render() {
      this.getCenter().addClass('card-hr');
      return '<hr />';
    }
  }], [{
    key: "cardName",
    get: function get() {
      return 'hr';
    }
  }, {
    key: "cardType",
    get: function get() {
      return CardType.BLOCK;
    }
  }, {
    key: "autoActivate",
    get: function get() {
      return false;
    }
  }, {
    key: "selectStyleType",
    get: function get() {
      return 'background';
    }
  }]);

  return Hr;
}(Card);

var _default = /*#__PURE__*/function (_Plugin) {
  _inherits(_default, _Plugin);

  var _super = _createSuper(_default);

  function _default() {
    _classCallCheck(this, _default);

    return _super.apply(this, arguments);
  }

  _createClass(_default, [{
    key: "init",
    value: function init() {
      var _this = this;

      this.editor.on('paser:html', function (node) {
        return _this.parseHtml(node);
      });
      this.editor.on('paste:schema', function (schema) {
        return _this.pasteSchema(schema);
      });
      this.editor.on('paste:each', function (child) {
        return _this.pasteHtml(child);
      });

      if (isEngine(this.editor)) {
        this.editor.on('keydown:enter', function (event) {
          return _this.markdown(event);
        });
        this.editor.on('paste:markdown', function (child) {
          return _this.pasteMarkdown(child);
        });
      }
    }
  }, {
    key: "execute",
    value: function execute() {
      if (!isEngine(this.editor)) return;
      var card = this.editor.card;
      card.insert(Hr.cardName);
    }
  }, {
    key: "hotkey",
    value: function hotkey() {
      return this.options.hotkey || 'mod+shift+e';
    }
  }, {
    key: "markdown",
    value: function markdown(event) {
      if (!isEngine(this.editor) || this.options.markdown === false) return;
      var _this$editor = this.editor,
          change = _this$editor.change,
          command = _this$editor.command,
          node = _this$editor.node;
      var range = change.getRange();
      if (!range.collapsed || change.isComposing() || !this.markdown) return;
      var blockApi = this.editor.block;
      var block = blockApi.closest(range.startNode);

      if (!node.isRootBlock(block)) {
        return;
      }

      var chars = blockApi.getLeftText(block);
      var match = /^[-]{3,}$/.exec(chars);

      if (match) {
        event.preventDefault();
        blockApi.removeLeftText(block);
        command.execute(this.constructor.pluginName);
        return false;
      }

      return;
    }
  }, {
    key: "pasteMarkdown",
    value: function pasteMarkdown(node) {
      if (!isEngine(this.editor) || !this.markdown || !node.isText()) return;
      var text = node.text();
      var reg = /(^|\r\n|\n)([-]{3,})\s?(\r\n|\n|$)/;
      var match = reg.exec(text);
      if (!match) return;
      var newText = '';
      var textNode = node.clone(true).get();
      var card = this.editor.card;

      while (textNode.textContent && (match = reg.exec(textNode.textContent))) {
        var _cardNode$get;

        //从匹配到的位置切断
        var regNode = textNode.splitText(match.index);
        newText += textNode.textContent; //从匹配结束位置分割

        textNode = regNode.splitText(match[0].length);
        var cardNode = card.replaceNode($(regNode), 'hr');
        regNode.remove();
        newText += ((_cardNode$get = cardNode.get()) === null || _cardNode$get === void 0 ? void 0 : _cardNode$get.outerHTML) + '\n';
      }

      newText += textNode.textContent;
      node.text(newText);
    }
  }, {
    key: "pasteSchema",
    value: function pasteSchema(schema) {
      schema.add([{
        type: 'block',
        name: 'hr',
        isVoid: true
      }]);
    }
  }, {
    key: "pasteHtml",
    value: function pasteHtml(node) {
      if (!isEngine(this.editor)) return;

      if (node.name === 'hr') {
        this.editor.card.replaceNode(node, Hr.cardName);
      }
    }
  }, {
    key: "parseHtml",
    value: function parseHtml(root) {
      root.find("[".concat(CARD_KEY, "=").concat(Hr.cardName)).each(function (hrNode) {
        var node = $(hrNode);
        var hr = node.find('hr');
        hr.css({
          'background-color': '#e8e8e8',
          border: '1px solid transparent',
          margin: '18px 0'
        });
        node.replaceWith(hr);
      });
    }
  }], [{
    key: "pluginName",
    get: function get() {
      return 'hr';
    }
  }]);

  return _default;
}(Plugin);

export default _default;
export { Hr as HrComponent };
