'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var engine = require('@aomao/engine');

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !Reflect.construct) return false;
  if (Reflect.construct.sham) return false;
  if (typeof Proxy === "function") return true;

  try {
    Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();

  return function _createSuperInternal() {
    var Super = _getPrototypeOf(Derived),
        result;

    if (hasNativeReflectConstruct) {
      var NewTarget = _getPrototypeOf(this).constructor;

      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }

    return _possibleConstructorReturn(this, result);
  };
}

function _superPropBase(object, property) {
  while (!Object.prototype.hasOwnProperty.call(object, property)) {
    object = _getPrototypeOf(object);
    if (object === null) break;
  }

  return object;
}

function _get(target, property, receiver) {
  if (typeof Reflect !== "undefined" && Reflect.get) {
    _get = Reflect.get;
  } else {
    _get = function _get(target, property, receiver) {
      var base = _superPropBase(target, property);

      if (!base) return;
      var desc = Object.getOwnPropertyDescriptor(base, property);

      if (desc.get) {
        return desc.get.call(receiver);
      }

      return desc.value;
    };
  }

  return _get(target, property, receiver || target);
}

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css_248z = ".am-engine .card-hr,.am-engine-view .card-hr {\r\n    border: 1px solid transparent;\r\n    padding: 18px 0;\r\n    border-radius: 2px 2px;\r\n}\r\n\r\n.am-engine .card-hr hr,.am-engine-view .card-hr hr {\r\n    box-sizing: border-box;\r\n    position: absolute;\r\n    top: 50%;\r\n    left: 0;\r\n    margin-top: -1px;\r\n    width: 100%;\r\n    height: 2px;\r\n    background-color: #e8e8e8;\r\n    padding: 0;\r\n    border: 1px solid transparent;\r\n}\r\n\r\n.am-engine .card-hr:hover , .am-engine .card-hr.hr-activated {\r\n    background-color: #f4f4f4;\r\n}";
styleInject(css_248z);

var Hr = /*#__PURE__*/function (_Card) {
  _inherits(Hr, _Card);

  var _super = _createSuper(Hr);

  function Hr() {
    _classCallCheck(this, Hr);

    return _super.apply(this, arguments);
  }

  _createClass(Hr, [{
    key: "toolbar",
    value: function toolbar() {
      if (!engine.isEngine(this.editor) || this.editor.readonly) return [];
      return [{
        type: 'dnd'
      }, {
        type: 'copy'
      }, {
        type: 'delete'
      }];
    }
  }, {
    key: "onActivate",
    value: function onActivate(activated) {
      _get(_getPrototypeOf(Hr.prototype), "onActivate", this).call(this, activated);

      var activatedClass = 'hr-activated';
      var center = this.getCenter();

      if (activated) {
        center.addClass(activatedClass);
      } else center.removeClass(activatedClass);
    }
  }, {
    key: "onSelectByOther",
    value: function onSelectByOther(selected, value) {
      _get(_getPrototypeOf(Hr.prototype), "onSelectByOther", this).call(this, selected, value);

      this.getCenter().find('hr').css('background-color', selected ? value.rgb : '');
    }
  }, {
    key: "onActivateByOther",
    value: function onActivateByOther(activated, value) {
      this.onSelectByOther(activated, value);
    }
  }, {
    key: "render",
    value: function render() {
      this.getCenter().addClass('card-hr');
      return '<hr />';
    }
  }], [{
    key: "cardName",
    get: function get() {
      return 'hr';
    }
  }, {
    key: "cardType",
    get: function get() {
      return engine.CardType.BLOCK;
    }
  }, {
    key: "autoActivate",
    get: function get() {
      return false;
    }
  }, {
    key: "selectStyleType",
    get: function get() {
      return 'background';
    }
  }]);

  return Hr;
}(engine.Card);

var _default = /*#__PURE__*/function (_Plugin) {
  _inherits(_default, _Plugin);

  var _super = _createSuper(_default);

  function _default() {
    _classCallCheck(this, _default);

    return _super.apply(this, arguments);
  }

  _createClass(_default, [{
    key: "init",
    value: function init() {
      var _this = this;

      this.editor.on('paser:html', function (node) {
        return _this.parseHtml(node);
      });
      this.editor.on('paste:schema', function (schema) {
        return _this.pasteSchema(schema);
      });
      this.editor.on('paste:each', function (child) {
        return _this.pasteHtml(child);
      });

      if (engine.isEngine(this.editor)) {
        this.editor.on('keydown:enter', function (event) {
          return _this.markdown(event);
        });
        this.editor.on('paste:markdown', function (child) {
          return _this.pasteMarkdown(child);
        });
      }
    }
  }, {
    key: "execute",
    value: function execute() {
      if (!engine.isEngine(this.editor)) return;
      var card = this.editor.card;
      card.insert(Hr.cardName);
    }
  }, {
    key: "hotkey",
    value: function hotkey() {
      return this.options.hotkey || 'mod+shift+e';
    }
  }, {
    key: "markdown",
    value: function markdown(event) {
      if (!engine.isEngine(this.editor) || this.options.markdown === false) return;
      var _this$editor = this.editor,
          change = _this$editor.change,
          command = _this$editor.command,
          node = _this$editor.node;
      var range = change.getRange();
      if (!range.collapsed || change.isComposing() || !this.markdown) return;
      var blockApi = this.editor.block;
      var block = blockApi.closest(range.startNode);

      if (!node.isRootBlock(block)) {
        return;
      }

      var chars = blockApi.getLeftText(block);
      var match = /^[-]{3,}$/.exec(chars);

      if (match) {
        event.preventDefault();
        blockApi.removeLeftText(block);
        command.execute(this.constructor.pluginName);
        return false;
      }

      return;
    }
  }, {
    key: "pasteMarkdown",
    value: function pasteMarkdown(node) {
      if (!engine.isEngine(this.editor) || !this.markdown || !node.isText()) return;
      var text = node.text();
      var reg = /(^|\r\n|\n)([-]{3,})\s?(\r\n|\n|$)/;
      var match = reg.exec(text);
      if (!match) return;
      var newText = '';
      var textNode = node.clone(true).get();
      var card = this.editor.card;

      while (textNode.textContent && (match = reg.exec(textNode.textContent))) {
        var _cardNode$get;

        //从匹配到的位置切断
        var regNode = textNode.splitText(match.index);
        newText += textNode.textContent; //从匹配结束位置分割

        textNode = regNode.splitText(match[0].length);
        var cardNode = card.replaceNode(engine.$(regNode), 'hr');
        regNode.remove();
        newText += ((_cardNode$get = cardNode.get()) === null || _cardNode$get === void 0 ? void 0 : _cardNode$get.outerHTML) + '\n';
      }

      newText += textNode.textContent;
      node.text(newText);
    }
  }, {
    key: "pasteSchema",
    value: function pasteSchema(schema) {
      schema.add([{
        type: 'block',
        name: 'hr',
        isVoid: true
      }]);
    }
  }, {
    key: "pasteHtml",
    value: function pasteHtml(node) {
      if (!engine.isEngine(this.editor)) return;

      if (node.name === 'hr') {
        this.editor.card.replaceNode(node, Hr.cardName);
      }
    }
  }, {
    key: "parseHtml",
    value: function parseHtml(root) {
      root.find("[".concat(engine.CARD_KEY, "=").concat(Hr.cardName)).each(function (hrNode) {
        var node = engine.$(hrNode);
        var hr = node.find('hr');
        hr.css({
          'background-color': '#e8e8e8',
          border: '1px solid transparent',
          margin: '18px 0'
        });
        node.replaceWith(hr);
      });
    }
  }], [{
    key: "pluginName",
    get: function get() {
      return 'hr';
    }
  }]);

  return _default;
}(engine.Plugin);

exports.HrComponent = Hr;
exports.default = _default;
